package zuora.metabuilder;

import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.TimeZone;
import java.util.UUID;
import java.util.function.Predicate;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;
import java.time.LocalDate;
import java.time.OffsetDateTime;
import org.hibernate.util.StringHelper;
//import org.hibernate.internal.util.StringHelper;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import com.zuora.enums.ByteEnum;
import com.zuora.enums.IntegerEnum;
import com.zuora.enums.StringEnum;

import zuora.metabuilder.Meta.ColumnInfo;
import zuora.metabuilder.Meta.State;
import zuora.metabuilder.Meta.TableInfo;

import com.google.common.base.Strings;
import com.zuora.base.*;

public class Utilities {
	public static class Tuple<A,B> {
		public A a; 
		public B b;
		Tuple(A a, B b) {
			this.a = a; this.b = b;
		}
	}
	
	// Returns a list of files that satisfies a condition
	static File[] listFiles(String dirName, final Predicate<String> p, String suffix) {
		File dir = new File(dirName);
		File[] files = dir.listFiles(new FilenameFilter() {
			  public boolean accept(File dir, String name) {
			     return (p != null ? p.test(name) : true) && name.endsWith(suffix);
			  }
		});
		return files;
	}

	static List<File> listFilesRecursive(String dirNameA, final Predicate<Path> p, String suffix) throws IOException {
		return Files.walk(Paths.get(dirNameA))
					.filter((Path x) -> {
						 if (p.test(x) && x.toString().endsWith(suffix))
							 return true;
						 return false;
					 })
					.map((Path x) -> x.toFile())
					.collect(Collectors.toList());
	}

	
	static public Map<String, Object> mergeMap(Map<String, Object> _this, Map<String, Object> _that) {
		Map<String, Object> ret = new HashMap<>();
		ret.putAll(_this);
		ret.putAll(_that);
		return ret;
	}
	
	static public Map<String, Map<String, Object>> mergeMapOfMap(Map<String, Map<String, Object>> _this, Map<String, Map<String, Object>> _that) {
		Map<String, Map<String, Object>> ret = new HashMap<>();
		
		if (_this != null) {
			for (Map.Entry<String, Map<String, Object>> me : _this.entrySet()) {
				Map<String, Object> _thatEntry = _that.get(me.getKey());
				if (_thatEntry != null) {
					Map<String, Object> ret2 = mergeMap(me.getValue(), _thatEntry);
					ret.put(me.getKey(), ret2);
				} else {
					ret.put(me.getKey(), me.getValue());
				}
			}
		}
		if (_that != null) {
			for (Map.Entry<String, Map<String, Object>> me : _that.entrySet()) {
				if (_this != null && !_this.containsKey(me.getKey()))
					ret.put(me.getKey(), me.getValue());
			}
		}
		return ret;
	}

	public static Tuple<Boolean, ColumnInfo> getOrCreateColumnInfo(TableInfo ti, String colName, String javaClass, 
																	Map<String, Map<String, Object>> props, State state,
																	String source) {
		ColumnInfo ci = ti.colMap.get(colName);
		boolean fExists = ci != null;
		if (!fExists) {
			ci = new ColumnInfo(ti.tableName, colName, javaClass, props);
			ci.state = state;
			ti.colMap.put(colName, ci);
		} else {
			ci.javaClass = javaClass;
			ci.annotations = Utilities.mergeMapOfMap(ci.annotations, props);
		}
		return new Tuple<>(fExists, ci);
	}
	
	public static void putColumnNameAnnotation(ColumnInfo ci, String colName) {
		Map<String, Map<String, Object>> mm = ci.annotations;
		if (mm == null) {
			mm = new HashMap<>();
			ci.annotations = mm;
		}
		Map<String, Object> m = mm.getOrDefault(Meta.c_ColumnNameAnnotationProperty, new HashMap<>());
		m.put(Meta.c_NameProperty, colName);
		mm.put(Meta.c_ColumnNameAnnotationProperty, m);
	}

    protected static String addUnderscores(String s) {
        char[] chars = s.toCharArray();
        StringBuilder sb = new StringBuilder();
        boolean previousWasUpperCase = true;
        for (int i = 0; i < chars.length; i++) {
            if (Character.isUpperCase(chars[i])) {
                if (!previousWasUpperCase) {
                    sb.append('_');
                }
                sb.append(Character.toLowerCase(chars[i]));
                previousWasUpperCase = true;
            } else {
                sb.append(chars[i]);
                previousWasUpperCase = false;
            }
        }

        return sb.toString();
    }

    public static String propertyToColumnName(String propertyName) {
        return addUnderscores(StringHelper.unqualify(propertyName));
    }
    
    public static TableInfo  getOrCreateTableInfo(Meta meta, String tableName, String className, String source) {
    	boolean fIsAutoGenerated = false;
    	
    	if (Strings.isNullOrEmpty(tableName)) {
			tableName = Utilities.classToTableName(className);
			fIsAutoGenerated = true;
    	}
    	boolean isView  = className.endsWith("DS"); 
    	boolean created = false;
    	
    	TableInfo ti = meta.tableMap.get(tableName);
    	if (ti == null) {
    		ti = new TableInfo(tableName, source);
    		ti.javaClass = className;
    		ti.isTableNameAutoGenerated = fIsAutoGenerated;
    		ti.source = source;
    		created = true;
    	} else {
    		ti.javaClass = className;
    		ti.source = source;
    	}
    	if (created) {
	    	if (isView) {
	    		List<TableInfo> viewList = meta.viewMap.get(tableName);
	    		if (viewList == null) {
	    			viewList = new ArrayList<>();
	    			meta.viewMap.put(tableName, viewList);
	    		}
				viewList.add(ti);
	    	} else {
	    		meta.tableMap.put(className, ti);
	    	}
    		meta.classMap.put(className, ti);
    	}
    	return ti;
    }
    
    private static String classToTableNameNoPrefix(String className) {
        return addUnderscores(StringHelper.unqualify(className));
    }

    public static String classToTableName(String className) {
        return "zb_" + classToTableNameNoPrefix(className);
    }
    
    static Pattern digits;
    static {
		String regex = "[0-9]+";
		digits = Pattern.compile(regex);
    }

    public static boolean stringIsOnlyDigits(String str) {
		if (str == null) {
			return false;
		}
		Matcher m = digits.matcher(str);
		return m.matches();
	}
    
    public static String getJavaClassFromHibernateType(String type) {
    	if (Strings.isNullOrEmpty(type))
    		return null;
    	
    	switch (type) {
	    	case "string": 		return String.class.getName();
	    	case "uuid":   		return UUID.class.getName();
	    	case "integer":		return Integer.class.getName();
	    	case "long":		return Long.class.getName();
	    	case "short":		return Short.class.getName();
	    	case "float":		return Float.class.getName();
	    	case "double":		return Double.class.getName();
	    	case "character":	return char.class.getName();
	    	case "byte":		return byte[].class.getName();
	    	case "boolean":		return Boolean.class.getName();
	    	case "yes_no":		return Boolean.class.getName();
	    	case "true_false":	return Boolean.class.getName();
	    	case "date":		return java.util.Date.class.getName();
	    	case "time":		return java.util.Date.class.getName();
	    	case "timestamp":	return Timestamp.class.getName();
	    	case "locale":		return Locale.class.getName();
	    	case "timezone":	return TimeZone.class.getName();
	    	case "currency":	return Decimal.class.getName();
	    	case "text":    	return String.class.getName();
	    	default:
	    		Debug();
	    		return type;
    	}
    }
    
    public static String[] _validDBTypes = {
	    	"string",
	    	"varchar",
	    	"uuid",
	    	"int",
	    	"integer",
	    	"bigint",
	    	"long",
	    	"smallint",
	    	"tinyint",
	    	"short",
	    	"float",
	    	"double",
	    	"bit",
	    	"boolean",
	    	"blob",
	    	"clob",
	    	"mediumblob",
	    	"true_false",
	    	"date",
	    	"time",
	    	"timestamp",
	    	"locale",
	    	"timezone",
	    	"numeric",
	    	"text", 
	    	"decimal"
    };
    public static Set<String> validDBTypes = new HashSet<>();
    static {
    	for (String s : _validDBTypes)
    		validDBTypes.add(s);
    }
    
    public static boolean IsValidHibernateType(String type) {
    	if (Strings.isNullOrEmpty(type))
    		return false;
    	
    	String replaced = type.replace("(", ",").replace(")", ",");
    	String[] split  = replaced.split(",");
    	return validDBTypes.contains(split[0]);
    }
    
    public static Class<?> getClassFromField(Class<?> struct, String field) throws ClassNotFoundException {
    	Class<?> ret  = null;
    	try {
    		Class<?> type = struct.getDeclaredField(field).getType();
    		if (type.isPrimitive()) {
    			if (type == short.class)
    				return Short.class;
    			if (type == int.class)
    				return Integer.class;
    			if (type == long.class)
    				return Long.class;
    			if (type == float.class)
    				return Float.class;
    			if (type == double.class)
    				return Double.class;
    			if (type == char.class)
    				return Character.class;
    			if (type == boolean.class)
    				return Boolean.class;
    		}
    		return type;
		} catch (NoSuchFieldException | NoClassDefFoundError ex) {
			throw new ClassNotFoundException();
		}
    }
    
    public static Class<?> getClassFromName(String className) {
    	try {
    		Class<?> clazz = Class.forName(className);
    		return clazz;
		} catch (ClassNotFoundException | NoSuchFieldError | NoClassDefFoundError ex) {
			return null;
		}
    }
    
    public static String getSqlTypeFromWellKnownClasses(Class<?> clazz) {
		if (clazz.isEnum()) {
			// Enumerations
			String ret = "tinyint(4)";
			if (clazz.isAssignableFrom(ByteEnum.class))
				return "tinyint(4) unsigned";
			else if (clazz.isAssignableFrom(IntegerEnum.class))
				return "int(11)";
			else if (clazz.isAssignableFrom(StringEnum.class))
				return "varchar(32)";
			return ret;
			
		} else if (clazz.isPrimitive()) {
			// Primitive Types
			if (clazz == int.class){
	    		return "int(11)";
	    	} else if (clazz == short.class){
	    		return "tinyint";
	    	} else if (clazz == long.class){
	    		return "bigint";
	    	} else if (clazz == float.class){
	    		return "float";
	    	} else if (clazz == double.class){
	    		return "double";
	    	} else if (clazz == char.class){
	    		return "char(1)";
	    	}			
	    } else {

	    	// Boxed Types
	    	if (clazz == Character.class){
	    		return "char(1)";
	    	} if (clazz == Integer.class){
	    		return "int(11)";
	    	} else if (clazz == Short.class){
	    		return "tinyint";
	    	} else if (clazz == Long.class){
	    		return "bigint(20)";
	    	} else if (clazz == Float.class){
	    		return "float";
	    	} else if (clazz == Double.class){
	    		return "double";
	    	} else if (clazz == Decimal.class){
	    		return "decimal(11,9)";
	    	} else if (clazz == com.zuora.base.Decimal.class){
	    		return "decimal(22,9)";
	    	} else if (clazz == java.util.Date.class){
	    		return "date";
	    	} else if (clazz == java.sql.Date.class){
	    		return "datetime";
	    	} else if (clazz == Timestamp.class){
	    		return "datetime";
	    	} else if (clazz == String.class){
	    		return "varchar(32)";
	    	} else if (clazz == UUID.class){
	    		return "varchar(32)";
	    	} else if (clazz == Byte.class){
	    		return "tinyint(4)";
	    	} else if (clazz == Boolean.class){
	    		return "bit(1)";
	    	} else if (clazz == java.math.BigDecimal.class){
	    		return "decimal(22,9)";
	    	} else if (clazz == java.util.Locale.class){
	    		return "varchar(32)";
	    	} else if (clazz == java.util.TimeZone.class || clazz == org.hibernate.type.TimeZoneType.class){
	    		return "varchar(80)";
	    	} else if (clazz == java.util.Calendar.class){
	    		return "datetime";
	    	} else if (clazz == java.time.LocalDate.class){
	    		return "date";
	    	} else if (clazz == java.time.OffsetDateTime.class){
	    		return "datetime";
	    	} else if (clazz.isAssignableFrom(java.util.List.class)) {
	    		return "varchar(5000)";
	    	} else
	    		return null;
	    }
		return null;
    }

    public static Tuple<String, String> getBaseTypeForCompositeType(String javaClass, Meta meta, ColumnInfo ci) {
    	Tuple<String, String> ret = null;
    	
    	if (javaClass.equals("com.zuora.zbilling.setting.model.Currency"))
    		Debug();
		
    	if (meta.classMap.containsKey(javaClass)) {
			 TableInfo tiTarget = meta.classMap.get(javaClass);
			 if (tiTarget.pkColumns.size() > 0) {
				 String pkTarget = Utilities.getAnElementFromSet(tiTarget.pkColumns);
				 if (tiTarget.colMap.containsKey(pkTarget)) {
					 ColumnInfo ciTarget = tiTarget.colMap.get(pkTarget);
					 ci.fkTo = ciTarget;
					 return new Tuple<>(ciTarget.javaClass, ciTarget.colType);
				 } else {
					 Utilities.Debug();
				 }
			 } else 
				 Utilities.Debug();
		} else {
			Class<?> clazz = getClassFromName(javaClass);
			if (clazz != null) {
				try {
					Class<?> fieldClass = Utilities.getClassFromField(clazz, "id");
					if (fieldClass != null)
						return new Tuple<>(fieldClass.getName(), "");
				} catch (Exception ex) {
					; // Gobble
				}
			}
		}
		return ret;
	}
        
	public static String getSqlTypeFromZuoraWellDefinedTypes(String javaClass) {
		return ExceptionTypes.getColTypeFromExceptions(javaClass);
	}
    
    public static void fillDBTypeFromColumnInfo(TableInfo ti, ColumnInfo ci, TableInfo tiTarget, ColumnInfo ciTarget, Meta meta) {
    	
     	// If we have already resolved, return
    	if (!Strings.isNullOrEmpty(ci.colType))
    		return;
    	
    	// should not have an empty javaClass
    	if (Strings.isNullOrEmpty(ci.javaClass)) {
    		Utilities.Debug();
    		return;
    	}
    	
    	// Fold this into the typefinding
    	if (ci.javaClass.startsWith("[B")) {
    		ci.colType = "mediumblob";
    		return;
    	}

    	if (ci.javaClass.equals("char"))
    		Debug();
        	
   	
    	// Resolve from exceptions
    	ci.colType = getSqlTypeFromZuoraWellDefinedTypes(ci.javaClass);
    	if (!Strings.isNullOrEmpty(ci.colType))
    		return;
    	
    	// Try well defined types
    	Class<?> clazz = getClassFromName(ci.javaClass);
    	if (clazz != null) {
    		ci.colType = getSqlTypeFromWellKnownClasses(clazz);
    	}
    	
    	// Try to resolve by chasing base types from composite types
    	if (ci.colType == null) {
    		Tuple<String,String> attemptedBaseType = getBaseTypeForCompositeType(ci.javaClass, meta, ci);
    		if (attemptedBaseType != null) {
    			if (Strings.isNullOrEmpty(attemptedBaseType.b)) {
	    			Class<?> attemptedClazz = getClassFromName(attemptedBaseType.a);
	    			if (attemptedClazz != null)
	    				ci.colType = getSqlTypeFromWellKnownClasses(attemptedClazz);
    			} else {
    				ci.colType = attemptedBaseType.b;
    			}
    		}
    	}
    	
    	// Print for future runs
		if (Strings.isNullOrEmpty(ci.colType)) {
//			System.out.printf("if (clazz == %s.class)\nreturn \"%s\";\n", ci.javaClass, ciTarget != null ? ciTarget.colType : "unknown1");
			System.out.printf("JavaClass->SQL: Cannot resolve for: (%s:%s) in {%s(%s)} (Reference: %s) {%s}\n", 
    				ci.colName, 
    				ci.javaClass,
    				ti.tableName, 
    				ti.javaClass,
    				ciTarget != null ? ciTarget.colType : "unknown1",
    				ti.source);
    		Debug();
		}
    }
       
	public static <T> T getAnElementFromSet(Set<T> x) {
		for (T t : x)
			return t;
		return null;
	}

	
	public static Set<String> compareSets(Set<String> thisSet, Set<String> refSet, Set<String> exclusions) {
		Set<String> right = new HashSet<>(refSet);
		Set<String> ret   = new HashSet<>();
		for (String s : thisSet) {
			if (right.contains(s))
				right.remove(s);
			else {
				if (!exclusions.contains(s))
					ret.add(s + "+");
			}
		}
		for (String s : right)
			if (!exclusions.contains(s))
				ret.add(s + "-");
		return ret;
	}

	// Recursively get a child element by name
	public static Element getElementByName(Element element, String name){
	    if(name.equals(element.getNodeName()))
	        return element;
	    for(int i=0; i < element.getChildNodes().getLength(); i++){
	        Node node = element.getChildNodes().item(i);
	        if (node.getNodeType() == Node.ELEMENT_NODE){
	            Element child = getElementByName((Element) node, name);
	            if(child != null)
	                return child;
	        }
	    }
	    return null;
	}

	// Recursively collect a list of elements in subtree
	public static  void getListOfElementsByName(Element element, String name, List<Element> ret){
	    
		if(name.equals(element.getNodeName()))
	        ret.add(element);
	    
	    for(int i = 0; i < element.getChildNodes().getLength(); i++){
	        Node node = element.getChildNodes().item(i);
	        if (node.getNodeType() == Node.ELEMENT_NODE){
	        	getListOfElementsByName((Element) node, name, ret);
	        }
	    }
	}

	public static void Debug() { ; }
}
